(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program gestion_erreur_allocation_tas;
  uses crt;
  type t_pt_o_nom = ^o_nom;
       o_nom = object
                 pt_nom_famille, pt_prenom: ^string;

                 destructor libere; virtual;

                 constructor cree_nom(p_nom_famille, p_prenom: string);

                 procedure affiche; virtual;
               end;
         t_pt_o_personne = ^o_personne;
         o_personne = object(o_nom)
                        pt_adresse, pt_telephone: ^string;

                        destructor libere; virtual;

                        constructor cree_personne(p_nom_famille, p_prenom,
                            p_adresse, p_telephone: string);

                        procedure affiche; virtual;
                      end;

  destructor o_nom.libere;
    begin
      if pt_prenom<> nil
        then dispose(pt_prenom);
      if pt_nom_famille<> nil
        then dispose(pt_nom_famille);
    end; 

  constructor o_nom.cree_nom(p_nom_famille, p_prenom: string);
    begin
      new(pt_nom_famille); new(pt_prenom);
      if (pt_nom_famille= nil) or (pt_prenom= nil)
        then begin
            libere;
            fail;
          end;
      pt_nom_famille^:= p_nom_famille; pt_prenom^:= p_prenom;
    end; 

  procedure o_nom.affiche;
    BEGIN
      write(pt_nom_famille^, ' ', pt_prenom^, ' ');
    end; 

  destructor o_personne.libere;
    begin
      if pt_adresse<> nil
        then dispose(pt_adresse);
      if pt_telephone<> nil
        then dispose(pt_telephone);
      o_nom.libere;
    end; 

  constructor o_personne.cree_personne(p_nom_famille, p_prenom,
      p_adresse, p_telephone: string);
    begin
      if not o_nom.cree_nom(p_nom_famille, p_prenom)
        then fail;
      new(pt_adresse); new(pt_telephone);
      if (pt_adresse= nil) or (pt_telephone= nil)
        then begin
            libere;
            fail;
          end;
      pt_adresse^:= p_adresse; pt_telephone^:= p_telephone;
    end; 

  procedure o_personne.affiche;
    BEGIN
      o_nom.affiche;
      write(pt_adresse^, ' ', pt_telephone^, ' ');
    end; 
  VAR le_createur_de_turbo: t_pt_o_nom;
      le_createur_de_pascal: t_pt_o_personne;
  (*$f+*)

  function heapfunc(p_taille: word): integer;
    begin
      heapfunc:= 1;
    end; 
  (*$f-*)
  BEGIN 
    clrscr;
    heaperror:= @heapfunc;
    new(le_createur_de_turbo, cree_nom('HELJSBERG', 'Anders'));
    new(le_createur_de_pascal, cree_personne('WIRTH', 'Niklaus', 'Zurich', '19.41 etc.'));
    if (le_createur_de_turbo= nil) or (le_createur_de_pascal= nil)
      then writeln('erreur')

      else begin
          le_createur_de_turbo^.affiche; writeln;
          le_createur_de_pascal^.affiche; writeln;
        end;
    if le_createur_de_pascal<> nil
      then dispose(le_createur_de_pascal, libere);
    if le_createur_de_turbo<> nil
      then dispose(le_createur_de_turbo, libere);
    readln;
  END. 

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
