(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program fichier_general;
  uses crt;
  type o_base= object

                 destructor libere; virtual;

                 procedure sauve(var pv_fichier: file); virtual;
               end;

  destructor o_base.libere;
    begin
    end; 

  procedure o_base.sauve(var pv_fichier: file);
    begin
    end; 
  var table_appel: array[1..2] of record
                                    adresse_table_procedures: integer;
                                    adresse_procedure_charge: pointer;
                                  end;

  procedure ecris(var pv_fichier: file; p_numero: integer;
      var pv_donnee; p_taille: integer);
    begin
      blockwrite(pv_fichier, p_numero, 2);
      blockwrite(pv_fichier, pv_donnee, p_taille);
    end; 

  procedure lis(var pv_fichier: file; var pv_donnee; p_taille: integer);
    begin
      blockread(pv_fichier, pv_donnee, p_taille);
    end; 

  procedure appelle(var pv_fichier: file; p_adresse_table_procedures: integer;
      var pv_donnee; pt_adresse_charge: pointer);
    begin
      inline(
             $C4/$7E/$0E/          
             $06/                  
             $57/                  
             $8B/$46/$0C/         
             $50/                 
             $31/$C0/             
             $50/                 
             $50/                 
             $FF/$5E/$04/          
             $C4/$7E/08/          
             $26/                 
             $89/$05/            
             $26/                 
             $89/$55/$02);        
    end; 

  procedure appelle_charge_du_descendant(var pv_fichier: file; var pv_donnee);
    var l_numero: integer;
    begin
      if eof(pv_fichier)
        then 
             fillchar(pv_donnee, 4, 0)
        else begin
            blockread(pv_fichier, l_numero, 2);
            appelle(pv_fichier, table_appel[l_numero].adresse_table_procedures, pv_donnee,
                table_appel[l_numero].adresse_procedure_charge);
          end;
    end; 
  type t_pt_o_cellule = ^o_cellule;
       o_cellule = object(o_base)
                     pt_suivante: t_pt_o_cellule;
                   end;
       t_pt_o_liste = ^o_liste;
       o_liste = object(o_base)
                   pt_debut_liste, pt_fin_liste: t_pt_o_cellule;

                   constructor initialise_liste;

                   procedure ajoute_fin(p_pt_o_cellule: t_pt_o_cellule);

                   procedure sauve(var pv_fichier: file); virtual;

                   constructor charge(var pv_fichier: file);
                 end;

  constructor o_liste.initialise_liste;
    begin
      pt_debut_liste:= nil;
      pt_fin_liste := nil;
    end; 

  procedure o_liste.ajoute_fin(p_pt_o_cellule: t_pt_o_cellule);
    begin
      p_pt_o_cellule^.pt_suivante:= nil;
      if pt_debut_liste = nil
        then pt_debut_liste := p_pt_o_cellule
        else pt_fin_liste^.pt_suivante := p_pt_o_cellule;
      pt_fin_liste := p_pt_o_cellule;
    end; 

  procedure o_liste.sauve(var pv_fichier: file);
    var l_pt_courant: t_pt_o_cellule;
    begin
      l_pt_courant:= pt_debut_liste;
      while l_pt_courant<> nil do
      begin
        l_pt_courant^.sauve(pv_fichier);
        l_pt_courant:= l_pt_courant^.pt_suivante;
      end;
    end; 

  constructor o_liste.charge(var pv_fichier: file);
    var l_pt_courant: t_pt_o_cellule;
    begin
      initialise_liste;
      repeat
        appelle_charge_du_descendant(pv_fichier, l_pt_courant);
        if l_pt_courant<> nil
          then ajoute_fin(l_pt_courant);
      until l_pt_courant= nil;
    end; 
  type 
       t_pt_o_cellule_affiche= ^o_cellule_affiche;
       o_cellule_affiche= object(o_cellule)

                            procedure affiche; virtual;
                          end;

  procedure o_cellule_affiche.affiche;
    begin
    end; 
  type t_pt_o_entier= ^o_entier;
       o_entier= object(o_cellule_affiche)
                   valeur: integer;

                   constructor initialise(p_entier: integer);

                   procedure affiche; virtual;

                   procedure sauve(var pv_fichier: file); virtual;

                   constructor charge(var pv_fichier: file);
                 end;

  constructor o_entier.charge(var pv_fichier: file);
    begin
      lis(pv_fichier, valeur, 2);
    end; 

  constructor o_entier.initialise(p_entier: integer);
    begin
      valeur:= p_entier;
      table_appel[1].adresse_table_procedures:= word(typeof(o_entier));
      table_appel[1].adresse_procedure_charge:= @o_entier.charge;
    end; 

  procedure o_entier.affiche;
    begin
      writeln('entier: ', valeur);
    end; 

  procedure o_entier.sauve(var pv_fichier: file);
    begin
      ecris(pv_fichier, 1, valeur, 2);
    end; 
  type t_pt_o_reel= ^o_reel;
       o_reel= object(o_cellule_affiche)
                 valeur: real;

                 constructor initialise(p_o_reel: real);

                 procedure sauve(var pv_fichier: file); virtual;

                 constructor charge(var pv_fichier: file);

                 procedure affiche; virtual;
               end;

  constructor o_reel.charge(var pv_fichier: file);
    begin
      lis(pv_fichier, valeur, 6);
    end; 

  constructor o_reel.initialise(p_o_reel: real);
    begin
      valeur:= p_o_reel;
      table_appel[2].adresse_table_procedures:= word(typeof(o_reel));
      table_appel[2].adresse_procedure_charge:= @o_reel.charge;
    end; 

  procedure o_reel.affiche;
    begin
      writeln('reel: ', valeur);
    end; 

  procedure o_reel.sauve(var pv_fichier: file);
    begin
      ecris(pv_fichier, 2, valeur, 6);
    end; 
  type o_liste_affiche= object(o_liste)

                          procedure affiche;
                        end;

  procedure o_liste_affiche.affiche;
    var l_pt_courant: t_pt_o_cellule_affiche;
    begin
      l_pt_courant:= t_pt_o_cellule_affiche(pt_debut_liste);
      while l_pt_courant<> nil do
      begin
        l_pt_courant^.affiche;
        l_pt_courant:= t_pt_o_cellule_affiche(l_pt_courant^.pt_suivante);
      end;
    end; 
  var choix: char;
      la_liste: o_liste_affiche;
      fichier: file;

  procedure cree_exemple;
    begin
      la_liste.initialise_liste;
      la_liste.ajoute_fin(new(t_pt_o_entier, initialise($22)));
      la_liste.ajoute_fin(new(t_pt_o_reel, initialise(0.75)));
      la_liste.ajoute_fin(new(t_pt_o_entier, initialise($33)));
      la_liste.ajoute_fin(new(t_pt_o_reel, initialise(0.875)));
    end; 

  procedure ecris_exemple;
    begin
      assign(fichier, 'a:sauve.dta');
      rewrite(fichier, 1);
      la_liste.sauve(fichier);
      close(fichier);
    end; 

  procedure relis_exemple;
    var l_entier: o_entier; l_reel: o_reel;
    begin
      l_entier.initialise(99);
      l_reel.initialise(3.14);
      assign(fichier, 'a:sauve.dta');
      reset(fichier, 1);
      la_liste.charge(fichier);
      close(fichier);
    end; 

  begin 
    clrscr;
    repeat
      write('Cre, Affiche, Ecris, Relis, Quitte ? ');
      choix:= readkey; writeln(choix);
      case choix of
        'a' : la_liste.affiche;
        'c' : cree_exemple;
        'e' : ecris_exemple;
        'r' : relis_exemple;
      end; 
    until choix= 'q';
  end. 
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
