(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)
unit liste;
  interface
    type t_pt_o_cellule = ^o_cellule;
         o_cellule = object
                       pt_suivante, pt_precedente: t_pt_o_cellule;

                       destructor fini; virtual;
                     end;
         o_liste = object
                     pt_debut_liste, pt_fin_liste: t_pt_o_cellule;

                     procedure initialise_liste;

                     procedure ajoute_fin(p_pt_cellule: t_pt_o_cellule);

                     procedure supprime_cellule(p_pt_cellule: t_pt_o_cellule);

                     function f_premiere_cellule: t_pt_o_cellule;

                     function f_cellule_suivante(p_pt_cellule: t_pt_o_cellule): t_pt_o_cellule;

                     function f_cellule_precedente(p_pt_cellule: t_pt_o_cellule): t_pt_o_cellule;

                     procedure supprime_liste;
                   end;
  implementation

    destructor o_cellule.fini;
      begin
      end; 

    procedure o_liste.initialise_liste;
      begin
        pt_debut_liste:= nil;
        pt_fin_liste:= nil;
      end; 

    procedure o_liste.ajoute_fin(p_pt_cellule: t_pt_o_cellule);
      begin
        if pt_debut_liste = nil
          then begin
              pt_debut_liste:= p_pt_cellule;
              p_pt_cellule^.pt_precedente:= pt_debut_liste;
            end
          else begin
              pt_fin_liste^.pt_suivante:= p_pt_cellule;
              p_pt_cellule^.pt_precedente:= pt_fin_liste;
            end;
        pt_fin_liste:= p_pt_cellule;
      end; 

    procedure o_liste.supprime_cellule(p_pt_cellule: t_pt_o_cellule);
      var l_pt_cellule_precedente: t_pt_o_cellule;
      begin
        if p_pt_cellule= pt_debut_liste
          then begin
              pt_debut_liste:= pt_debut_liste^.pt_suivante;
              if pt_debut_liste= nil
                then pt_fin_liste:= nil;
            end
          else begin
              l_pt_cellule_precedente:= p_pt_cellule;
              l_pt_cellule_precedente^.pt_suivante:= p_pt_cellule^.pt_suivante;
              if pt_fin_liste = p_pt_cellule
                then pt_fin_liste:= l_pt_cellule_precedente;
            end;
        dispose(p_pt_cellule, fini);
      end; 

    function o_liste.f_premiere_cellule: t_pt_o_cellule;
      begin
        f_premiere_cellule:= pt_debut_liste;
      end; 

    function o_liste.f_cellule_precedente(p_pt_cellule: t_pt_o_cellule): t_pt_o_cellule;
      begin
        if p_pt_cellule = pt_debut_liste
          then f_cellule_precedente:= nil
          else f_cellule_precedente:= p_pt_cellule^.pt_precedente;
      end; 

    function o_liste.f_cellule_suivante(p_pt_cellule: t_pt_o_cellule): t_pt_o_cellule;
      begin
        if p_pt_cellule = pt_fin_liste
          then f_cellule_suivante:= nil
          else f_cellule_suivante:= p_pt_cellule^.pt_suivante;
      end; 

    procedure o_liste.supprime_liste;
      var l_pt_cellule: t_pt_o_cellule;
      begin
        while pt_debut_liste<> nil do
        begin
          l_pt_cellule:= pt_debut_liste;
          supprime_cellule(l_pt_cellule);
        end;
      end; 
  end.

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
