(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)
unit ustream;
  interface
    type t_pt_o_base= ^o_base;
         o_base= object

                   destructor libere; virtual;
                 end;
    type t_pt_o_info= ^o_info;
         o_info= object
                   signature: word;
                   adresse_table_procedures: word;
                   adresse_procedure_sauve, adresse_procedure_charge: pointer;
                   pt_suivant: t_pt_o_info;
                 end;
         o_stream= object
                     pt_info: t_pt_o_info;
                     fichier: file;

                     procedure initialise;

                     procedure enregistre(p_signature: word; p_adresse_table_procedures,
                         p_adresse_procedure_sauve, p_adresse_procedure_charge: pointer);

                     procedure cherche_info(p_adresse_table_procedures: word;
                         var pv_pt_info: t_pt_o_info);

                     procedure cherche_info_par_signature(p_signature: word;
                         var pv_pt_info: t_pt_o_info);

                     procedure cree(p_nom: string);

                     procedure ouvre(p_nom: string);

                     procedure ferme;

                     procedure ecris_disque(var pv_donnee; p_taille: word);

                     procedure lis_disque(var pv_donnee; p_taille: word);

                     function f_fin_fichier: boolean;

                     procedure met(var pv_base: o_base);

                     function f_alloue_et_retire: t_pt_o_base;

                     procedure retire(var pv_base: o_base);

                     destructor libere;
                   end;
  implementation

    destructor o_base.libere;
      begin
      end; 

    procedure o_stream.initialise;
      begin
        pt_info:= nil;
      end; 

    procedure o_stream.enregistre(p_signature: word; p_adresse_table_procedures,
          p_adresse_procedure_sauve, p_adresse_procedure_charge: pointer);
      var l_pt_auxiliaire: t_pt_o_info;
      begin
        new(l_pt_auxiliaire);
        with l_pt_auxiliaire^ do
        begin
          signature:= p_signature;
          adresse_table_procedures:= word(p_adresse_table_procedures);
          adresse_procedure_sauve:= p_adresse_procedure_sauve;
          adresse_procedure_charge:= p_adresse_procedure_charge;
          pt_suivant:= pt_info;
        end; 
        pt_info:= l_pt_auxiliaire;
      end; 

    procedure o_stream.cherche_info(p_adresse_table_procedures: word;
        var pv_pt_info: t_pt_o_info);
      var l_trouve: boolean;
      begin
        pv_pt_info:= pt_info;
        l_trouve:= false;
        while not l_trouve and (pv_pt_info<> nil) do
          if pv_pt_info^.adresse_table_procedures= p_adresse_table_procedures
            then l_trouve:= true
            else pv_pt_info:= pv_pt_info^.pt_suivant;
        if not l_trouve
          then begin
              writeln('pas enregistr cet objet ', p_adresse_table_procedures);
              halt;
            end;
      end; 

    procedure o_stream.cherche_info_par_signature(p_signature: word;
         var pv_pt_info: t_pt_o_info);
      var l_trouve: boolean;
      begin
        pv_pt_info:= pt_info;
        l_trouve:= false;
        while not l_trouve and (pv_pt_info<> nil) do
          if pv_pt_info^.signature= p_signature
            then l_trouve:= true
            else pv_pt_info:= pv_pt_info^.pt_suivant;
        if not l_trouve
          then begin
              writeln('pas enregistr cet objet ', p_signature);
              halt;
            end;
      end; 

    procedure o_stream.cree(p_nom: string);
      begin
        assign(fichier, p_nom);
        rewrite(fichier, 1);
      end; 

    procedure o_stream.ouvre(p_nom: string);
      begin
        assign(fichier, p_nom);
        reset(fichier, 1);
      end; 

    procedure o_stream.ferme;
      begin
        close(fichier);
      end; 

    procedure o_stream.ecris_disque(var pv_donnee; p_taille: word);
      begin
        blockwrite(fichier, pv_donnee, p_taille);
      end; 

    procedure o_stream.lis_disque(var pv_donnee; p_taille: word);
      begin
        blockread(fichier, pv_donnee, p_taille);
      end; 

    function o_stream.f_fin_fichier: boolean;
      begin
        f_fin_fichier:= eof(fichier);
      end; 

    procedure o_stream.met(var pv_base: o_base);

      type t_appel_sauve= procedure(var pv_o_stream: o_stream; var pv_base: o_base);
      var l_appel_sauve: t_appel_sauve;
          l_pt_info: t_pt_o_info;
      begin
        cherche_info(word(typeof(pv_base)), l_pt_info);
        with l_pt_info^ do
        begin
          ecris_disque(signature, 2);
          l_appel_sauve:= t_appel_sauve(adresse_procedure_sauve);
          l_appel_sauve(self, pv_base);
        end;
      end; 

    function o_stream.f_alloue_et_retire: t_pt_o_base;

      type t_appel_charge= function(var pv_stream: o_stream;
              p_adresse_table_procedures: word; p: pointer): t_pt_o_base;
      var l_signature: word;
          l_appel_charge: t_appel_charge;
          l_pt_info: t_pt_o_info;
      begin
        if not f_fin_fichier
          then begin
              lis_disque(l_signature, 2);
              cherche_info_par_signature(l_signature, l_pt_info);
              with l_pt_info^ do
              begin
                l_appel_charge:= t_appel_charge(adresse_procedure_charge);
                f_alloue_et_retire:= l_appel_charge(self, adresse_table_procedures, nil);
              end; 
          end 
        else f_alloue_et_retire:= nil;
      end; 

    procedure o_stream.retire(var pv_base: o_base);

      type t_appel_charge= procedure(var pv_stream: o_stream;
              p_adresse_table_procedures: word; p: pointer);
      var l_signature: word;
          l_appel_charge: t_appel_charge;
          l_pt_info: t_pt_o_info;
      begin
        if not f_fin_fichier
          then begin
              lis_disque(l_signature, 2);
              cherche_info_par_signature(l_signature, l_pt_info);
              with l_pt_info^ do
              begin
                l_appel_charge:= t_appel_charge(adresse_procedure_charge);
                l_appel_charge(self, adresse_table_procedures, @pv_base);
              end; 
          end; 
      end; 

    destructor o_stream.libere;
      var l_pt_o_info: t_pt_o_info;
      begin
        l_pt_o_info:= pt_info;
        while l_pt_o_info<> nil do
        begin
          l_pt_o_info:= l_pt_o_info^.pt_suivant;
          dispose(pt_info);
        end; 
      end; 

    begin 
    end. 
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
